//---------------------------------------------------------------------------
#ifndef SAnimBMPH
#define SAnimBMPH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ComCtrls.hpp>
#include "SMarkee.h"
#include <memory>       //for STL auto_ptr
#include <vcl/dsgnintf.hpp>

class TFrame : public TCollectionItem
{
private:
    Graphics::TBitmap * FBitmap;
    void __fastcall SetBitmap(Graphics::TBitmap *Value);
    int FTime;
public:
	__fastcall TFrame(TCollection* Collection);
    __fastcall ~TFrame();
    void __fastcall Assign(TPersistent* Source);
__published:
    __property Graphics::TBitmap *Bitmap = {read=FBitmap, write=SetBitmap, stored=true};
    __property int Time = {read=FTime, write=FTime, stored=true};
};

//---------------------------------------------------------------------------
class TAnimBMPProperty : public TClassProperty
{
public:
	virtual TPropertyAttributes __fastcall GetAttributes(void);
	virtual void __fastcall Edit(void);
	AnsiString __fastcall TAnimBMPProperty::GetValue();    
public:
	__fastcall virtual TAnimBMPProperty(void);
	__fastcall virtual ~TAnimBMPProperty(void);
};

//---------------------------------------------------------------------------
class TSAnimBMP : public TCustomControl
{
private:
	TImageList * FBitmaps;
    TCollection * FFrames;
    bool FAutosize;
    int Index;
	void __fastcall SetFrames(TCollection *Value);
    void __fastcall SetBitmaps(TImageList *Value);
	void __fastcall Paint();
    void __fastcall Loaded(void);
    void __fastcall SetNextFrame();
    MESSAGE void __fastcall OnTimer(Messages::TWMTimer &Message);
    MESSAGE void __fastcall OnCreate(Messages::TWMCreate &Message);
protected:
public:
	__fastcall TSAnimBMP(TComponent* Owner);
    __fastcall ~TSAnimBMP();
__published:
	__property TImageList *Bitmaps = {read=FBitmaps, write=SetBitmaps, stored=true};
	__property TCollection *Frames = {read=FFrames, write=SetFrames, stored=true};
    __property bool Autosize = {read=FAutosize, write=FAutosize, default=true};
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_TIMER, Messages::TWMTimer, OnTimer);
	MESSAGE_HANDLER(WM_CREATE, Messages::TWMCreate, OnCreate);
END_MESSAGE_MAP(TCustomControl);
};

//---------------------------------------------------------------------------
class TAnimForm : public TForm
{
__published:	// IDE-managed Components
	TButton *NextButton;
	TImage *Image1;
	TButton *PrevButton;
	TLabel *Label1;
	TEdit *Edit1;
	TLabel *Label2;
	TUpDown *UpDown1;
	TButton *AddButton;
	TOpenDialog *OpenBitmap;
	TButton *InsertButton;
	TButton *DeleteButton;
	TButton *Button1;
	TButton *Button2;
	TSMarkee *SMarkee1;
	void __fastcall AddBitmap(TObject *Sender);
	void __fastcall PrepareForm(TObject *Sender);
	void __fastcall PrevPicture(TObject *Sender);
	void __fastcall NextPicture(TObject *Sender);
	void __fastcall InsertBitmap(TObject *Sender);
	void __fastcall DeleteBitmap(TObject *Sender);
	void __fastcall ChangeTime(TObject *Sender);
private:	// User declarations
	int Index;
    void __fastcall UpdatePicture();
    void __fastcall SortFrames(int index);
public:		// User declarations
	__fastcall TAnimForm(TComponent* Owner);
    virtual __fastcall ~TAnimForm();
    TCollection *Frames;
};

//-- var, const, procedure ---------------------------------------------------
//---------------------------------------------------------------------------
extern TAnimForm *AnimForm;
bool __fastcall EditBitmaps(TCollection *Frames);
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#endif
